<?php

namespace OneSender\Uncanny;

defined('ABSPATH') or die('No direct access allowed to this file');

class Encryption {
    public static function generate_key_pair() {
        $zr0 = array(
            'digest_alg' => 'sha1',
            'private_key_bits' => 2048,
            'encrypt_key' => TRUE
        );

        $hg1 = openssl_pkey_new();
        openssl_pkey_export($hg1, $rw2);
        $at3 = openssl_pkey_get_details($hg1);
        $at3 = $at3['key'];
        return array(
            'private_key' => $rw2,
            'public_key' => $at3
        );
    }

    public static function rsa_encrypt( string $fu4, string $at3 ) {
        openssl_public_encrypt( $fu4, $ub5, $at3 );
        return base64_encode($ub5);
    }

    public static function rsa_decrypt( string $fd6, string $rw2 ) {
        $fd6 = base64_decode( $fd6 );
        openssl_private_decrypt( $fd6, $bq7, $rw2 );
        return $bq7;
    }


    public static function generate_box_key() {
        return base64_encode( openssl_random_pseudo_bytes( 32 ) );
    }

    public static function box_encrypt( $hp8 = '', $ac9 = '' ) {
        if (empty($ac9)) {
            $ac9 = base64_decode( Setting::instance()->get('box_key', '') );
        } else {
            $ac9 = base64_decode( $ac9 );
        }

        $yx10 = openssl_random_pseudo_bytes( 16 );
        $zn11 = openssl_encrypt( $hp8, 'AES-256-CBC', $ac9, OPENSSL_RAW_DATA, $yx10 );

        if (!$zn11) {
            return false;
        }

        $zn11 = base64_encode($zn11) . ':' . base64_encode($yx10);
        return base64_encode($zn11);
    }

    public static function box_decrypt( $zn11 = '', $ac9 = null ) {
        if (empty($ac9)) {
            $ac9 = base64_decode( Setting::instance()->get('box_key', '') );
        } else {
            $ac9 = base64_decode( $ac9 );
        }

        $ac12 = explode(':', base64_decode($zn11));
     
        if (count($ac12) !== 2) {
            return false;
        }
     
        $bq7 = openssl_decrypt(
            base64_decode($ac12[0]), 
            'AES-256-CBC', 
            $ac9, 
            OPENSSL_RAW_DATA, 
            base64_decode($ac12[1])
        );

        return $bq7;
    }
}
