<?php

namespace OneSender\Uncanny;

defined('ABSPATH') or die('No direct access allowed to this file');

use OneSender\Uncanny\Uncanny\OneSender;
class Plugin {

    public static $instance;

    public static function instance() {
        if (empty(self::$instance)) {
            self::$instance = new Plugin();
        }

        return self::$instance;
    }

    public function __construct() {
        $this->load_modules();
        $this->integration();
    }

    private function load_modules() {
        $modules = array(
            'OneSender\Uncanny\Modules\Admin\Admin_Menu',
            'OneSender\Uncanny\Modules\Ajax\Ajax_Calls'
        );

        foreach ( $modules as $module ) {
            $module::init();
        }
    }

    private function integration() {
        new OneSender();
    }
}
