<?php

namespace OneSender\Uncanny;

defined('ABSPATH') OR exit('No direct script access allowed');

class Repository {

	public static $instance;

	public static function instance() {
		if (empty(self::$instance)) {
			self::$instance = new Repository();
		}
		return self::$instance;
	}

	const PLUGIN_KEY = 'onesender-uncanny';
	const PLUGIN_PATH = 'onesender-uncanny/onesender-uncanny.php';
	const REPO_URL = 'https://repository.plugin.my.id/api/repo/v1';
	// const REPO_URL = 'https://enqjuyfgaqk1t.x.pipedream.net';

	protected $activated;

	public function __construct() {
		$this->activated = self::is_activated();
		add_action( 'wp_ajax_osunp_register', array($this, 'XsCmi') );
		add_action( 'wp_ajax_nopriv_osunp_register', array($this, 'XsCmi') );
		add_action( 'wp_ajax_osunp_validate', array($this, 'YjWWu') );
		add_action( 'wp_ajax_nopriv_osunp_validate', array($this, 'YjWWu') );
		add_filter( 'site_transient_update_plugins',  array( $this, 'ynTJy' ) );
		add_filter( 'transient_update_plugins',  array( $this, 'ynTJy' ) );
		add_filter( 'plugins_api', array( $this, 'NSKKl'), 20, 3 );
	}

	public function activated() {
		return $this->activated;
	}

	private function lqNDm( $alvaq = array() ) {
		$UqGHQ = [];	

		$qHRuA = ['sodium', 'ioncube', 'ds'];
		foreach($qHRuA as $XMJQr){
			if (extension_loaded($XMJQr)) {
				$UqGHQ[] = $XMJQr;
			} 
		}

		$wFtzW = get_option( '_onesender_uncanny_instance_id', false );
		if ( !$wFtzW ) {
			$wFtzW = osun_uuidv4();
			update_option( '_onesender_uncanny_instance_id', $wFtzW, true );
		}

		$xwkGe = [
		    'plugin' 		 => 'onesender-uncanny',
			'instance_id' 	 => $wFtzW,
			'content_path' 	 => WP_CONTENT_DIR,
		    'plugin_version' => OSUN_VERSION,
		    'wp_version'     => get_bloginfo('version'),
		    'php_version'    => phpversion() ,
		    'home_url'       => home_url(),
		    'admin_url'      => admin_url(),
		    'public_key'     => osun_get_option( 'public_key' ),
		    'private_key'    => osun_get_option( 'private_key' ),
		    'box_key' 		 => osun_get_option( 'box_key' ),
		    'modules' 		 => $UqGHQ,
		];

		$xwkGe = array_merge( $alvaq, $xwkGe );

		return $xwkGe;
	}


	public function XsCmi() {
		global $current_user;

		if (!isset($current_user->allcaps['administrator'])) {
			return wp_send_json([
				'success' => false,
				'message' => 'Unauthorized access',
			]);
		}

		$anhMI = self::BTuFH();
		if (count($anhMI) == 0) {
			return wp_send_json([
				'success' => false,
				'message' => 'Request parameters are invalid',
			]);
		}

		$anhMI = wp_parse_args($anhMI, array(
			'email' => '',
			'nonce' => '',
		));

		if ( !filter_var( $anhMI['email'], FILTER_VALIDATE_EMAIL ) ) {
			return wp_send_json([
				'success' => false,
				'message' => 'E-Mail invalid',
			]);
		}

		if ( !wp_verify_nonce( $anhMI['nonce'] ) ) {
			return wp_send_json([
				'success' => false,
				'message' => 'Session invalid',
			]);
		}

		$jXkJm = $this->lqNDm(array(
			'email' => $anhMI['email'] ?? '',
		    'hash' 	=> md5_file( OSUN_PATH . 'inc' )
		));

		$KQZwt = self::REPO_URL . '/instance/register/plugin/';
		 
		$ntBTm = array( 
		    'Content-Type' => 'application/json'
		);
		 
		$jbRUI = array(
		    'body' 			=> json_encode( $jXkJm ),
		    'sslverify'     => false,
		    'headers'       => $ntBTm,
		    'method'        => 'POST',
		    'data_format'   => 'body'
		);
		 
		$fDLfI = wp_remote_post( $KQZwt, $jbRUI );
		 
		if ( is_wp_error( $fDLfI ) ) {
			return wp_send_json([
				'success' => false,
				'message' => 'Query failed',
				'errors'  => $fDLfI->get_error_message(),
			]);

		} 
		
		$GTrFT     = json_decode( wp_remote_retrieve_body( $fDLfI ) );
		return wp_send_json($GTrFT);
	}


	public function YjWWu() {
		global $current_user;

		if (!isset($current_user->allcaps['administrator'])) {
			return wp_send_json([
				'success' => false,
				'message' => 'Unauthorized access',
			]);
		}

		$RAPCV = self::BTuFH();
		$RAPCV = wp_parse_args( $RAPCV, array(
		    'request_id' => '',
		    'otp_code' => '',
		) );
		
		if (count($RAPCV) == 0) {
			return wp_send_json([
				'success' => false,
				'message' => 'Request parameters are invalid',
			]);
		}

		$SApqS = self::REPO_URL . '/instance/validate/';
		$RTUUq = array( 
		    'Content-Type' => 'application/json'
		);
		 
		$Npuea = array(
		    'body' 			=> json_encode( $RAPCV ),
		    'sslverify'     => false,
		    'headers'       => $RTUUq,
		    'method'        => 'POST',
		    'data_format'   => 'body'
		);
		 
		$cUFpt = wp_remote_post( $SApqS, $Npuea );
		 
		if ( is_wp_error( $cUFpt ) ) {
			return wp_send_json([
				'success' => false,
				'message' => 'Query failed',
				'errors'  => $cUFpt->get_error_message(),
			]);
		} 
		
		$SEjnS     = json_decode( wp_remote_retrieve_body( $cUFpt ), true );
		if( $SEjnS['success'] ) {
			$LUbhQ = $SEjnS['data']['info'] ?? '';
			$wLBrD = Encryption::box_encrypt( json_encode( $LUbhQ ), osun_get_option( 'box_key' ) );
			update_option( '_onesender_uncanny_instance_info', $wLBrD, true );
		}
		return wp_send_json($SEjnS);
		
	}

	public function ynTJy( $IeexH ) {

		if ( ! is_object( $IeexH ) )
			return $IeexH;

		if ( ! isset( $IeexH->response ) || ! is_array( $IeexH->response ) )
			$IeexH->response = array();

	    $Fgxbz = (int) wp_date('U');
	    $xqvLv = (int) get_option('_osun_next_check_update', ($Fgxbz - 10) );
	    $XzfMz = get_option('_osun_data_update', false );

	    $KClKj = $_GET['force_update'] ?? false;
	    if ($xqvLv < $Fgxbz || $KClKj) {
	    	
	    	$lzUdp = $this->yhKaR();
    		$lzUdp = json_decode( $lzUdp[ 'body' ], true );

    		if ( is_wp_error( $lzUdp ) ) {
    			$xqvLv = $Fgxbz + apply_filters( 'osun/check_interval/error', 900 );
    			update_option( '_osun_next_check_update', $xqvLv, true );
    		} else {
    			if ( isset($lzUdp['success']) && $lzUdp['success'] == true ) {
    				$jVvww = $lzUdp['data']['update'];
    				$SSEdv = $jVvww['new_version'] ?? '0.1.0';
    				if( version_compare(OSUN_VERSION, $SSEdv) <= 0 ) {
    					$XzfMz = (object) $jVvww;
	    				$xqvLv = $Fgxbz + apply_filters( 'osun/check_interval', 21600 );
    					update_option( '_osun_next_check_update', $xqvLv, true );
    					update_option( '_osun_data_update', $XzfMz, true );
    				} else {
    					$XzfMz = false;
    					update_option('_osun_data_update', $XzfMz, true );
    				}
    			}
    		}
	    }

	    if (isset($XzfMz->new_version)) {
	    	if(OSUN_VERSION == $XzfMz->new_version) {
	    		update_option('_osun_data_update', false, true );
	    	} else {
	    		$IeexH->response[self::PLUGIN_PATH] = $XzfMz;
	    	}
	    }

		return $IeexH;
	}


	public function NSKKl( $DHXmP, $urGoY, $EzbPu ) {
	    if ( $urGoY !== 'plugin_information' ) {
	        return false;
	    }

	    if ( self::PLUGIN_KEY !== $EzbPu->slug ) {
	        return $DHXmP;
	    }

		$vADFZ = $this->yhKaR();

	    if ( is_wp_error( $vADFZ ) ) {
	    	return false;
	    }

	    $PJqFT = json_decode( $vADFZ[ 'body' ], true );

	    if ( isset($PJqFT['success']) && $PJqFT['success'] == true && isset($PJqFT['data']['info'])) {

	    	$CXslF = (object) $PJqFT['data']['info'];
	    	return $CXslF;
	    }

	    return false;
	}

	private function yhKaR() {

		$NwjeG 				= get_option( '_onesender_uncanny_instance_id', '' );
		$EYPeU 				= self::REPO_URL . '/update/plugin/' . $NwjeG;
		$YazQT 				= array( 'sid' => $NwjeG );
		$qMQcM 				= $this->lqNDm( $YazQT );
		$cKQGI 				=  array(
			'timeout' 		=> 30,
			'body' 			=> json_encode( $qMQcM ),
			'sslverify' 	=> false,
			'method' 		=> 'POST',
			'headers' 		=> array(
				'Accept' 	=> 'application/json'
	        ),
		);
		
		return wp_remote_post( $EYPeU, $cKQGI );
	}

	public static function is_activated() {
		$HMXWH = get_option( '_onesender_uncanny_instance_info', false );
		if (!$HMXWH) 
			return false;
		$HMXWH = Encryption::box_decrypt( $HMXWH, osun_get_option( 'box_key' ) );
		$HMXWH = json_decode( $HMXWH, true );
		$SZWAS 	 = $HMXWH['status'] ?? false;
		return $SZWAS === 'valid';
	}

	public static function BTuFH() {
		$rLSpe = file_get_contents('php://input');
		$rLSpe = json_decode( $rLSpe, true );
		if (json_last_error() !== JSON_ERROR_NONE) {
			return array();
		}

		return $rLSpe;
	}
}