<?php

namespace OneSender\Uncanny;

defined('ABSPATH') OR exit('No direct script access allowed');

class Setting {

    public static $instance;

    public static function instance() {
        if ( empty( self::$instance ) ) {
            self::$instance = new Setting();
        }

        return self::$instance;
    }

    protected $settings = [];

    public function __construct() {
        if (count($this->settings) == 0) {
            $this->set_settings();
        }
    }

    public static function get_default_settings() {
		return array(
            'repo_public_key' => '',
            'public_key' => '',
            'private_key' => '',
            'box_key' => '',
            'onesender_api_url' => '',
			'onesender_api_key' => '',
            'aktifkan' => '',
		);
    }

    public function get_settings() {
        return $this->settings;
    }

    public function set_settings() {
        $options = get_option( '_onesender_uncanny_setting', array() );
        $options = wp_parse_args( $options, self::get_default_settings() );
        $this->settings = $options;
    }

    public function get_setting( $key = '', $default = null) {
        return $this->settings[$key] ?? $default;
    }

    public function mutate( $key = '', $value = '') {
        if ( ! isset($this->settings[$key]) ) return false;

        $this->settings[$key] = $value;

        return true;
    }

    public function update_setting( $key = '', $value = '') {

        $ops = $this->mutate( $key, $value );

        if ( $ops ) {
            update_option( '_onesender_uncanny_setting', $this->settings );
        }

        return true;
    }

    public function get( $key = '', $default = null ) {
        return $this->get_setting( $key, $default );
    }
    
    public function set( $key = '', $data = '' ) {
        return $this->update_setting( $key, $data );
    }
}

