<?php

namespace OneSender\Uncanny;

defined('ABSPATH') OR exit('No direct script access allowed');


use OneSender\Uncanny\OneSender_Client;

class Wasender {
	public static $instance;

    public static function instance() {
        if (empty(self::$instance)) {
            self::$instance = new Wasender();
        }

        return self::$instance;
    }

    protected $sender = false;

    public function __construct() {
        $url = osun_get_option( 'onesender_api_url', '' );
        $key = osun_get_option( 'onesender_api_key', '' );

        $errors = osun_collect([]);

        if (empty($url)) {
            $errors->put('api_url', array('Api url tidak valid'));
        }

        if (empty($key)) {
            $errors->put('api_key', array('Api key tidak valid'));
        }

        if ($errors->count() > 0) {
            $output = [
            	true, 
            	[], 
            	$errors->toArray(),
            ];
        }

        $args = array(
            'api_url' => $url,
            'api_key' => $key
        );

        $this->sender = new OneSender_Client( $args );
    }

    public function send( array $recipients, string $message ) {
    	if ( !$this->sender ) {
    		return [false, [], ['sender' => 'Sender not available']];
    	}

    	foreach($recipients as $to) {
	    	$all_message[] = $this->sender->to( $to )
			    ->content( $message )
			    ->save();
    	}

    	list($delivery, $errors) = $this->sender->send( $all_message );
    	$errors = is_array($errors) ? $errors : array();
        $success = count( $errors ) == 0;

        return [$success, $delivery, $errors];
    }
}