<?php

namespace OneSender\Uncanny\Modules\Ajax;

defined('ABSPATH') or die('No direct access allowed to this file');

use Valitron\Validator;
use OneSender\Uncanny\OneSender_Client;
use OneSender\Uncanny\Wasender;

class Test_Connection {

	public function response() {
        
        $url = osun_get_option( 'onesender_api_url', '' );
        $key = osun_get_option( 'onesender_api_key', '' );

        $errors = osun_collect([]);

        if (empty($url)) {
            $errors->push('api_url', array('Api url tidak valid'));
        }

        if (empty($key)) {
            $errors->push('api_key', array('Api key tidak valid'));
        }

        if ($errors->count() > 0) {
            $output = [
                'success' => true,
                'message' => 'Test connection',
                'data' => [],
                'errors' => $errors->toArray(),
            ];

            return wp_send_json( $output );
        }

        $args = array(
            'api_url' => $url,
            'api_key' => $key
        );

        $sender     = new OneSender_Client( $args );
        $message    = 'Test Integrasi OneSender Uncanny Automator. Dari website: ' . home_url();
        $message    = apply_filters('osun/test_message/content', $message );

        $recipient  = '6289508618321';
        $recipient  = apply_filters('osun/test_message/recipient', $recipient );
        if (is_string($recipient)) {
            $recipient = array($recipient);
        }
        
        list($success, $delivery, $error) = Wasender::instance()->send( $recipient, $message );

        if ( !$success ) {
            return wp_send_json([
                'success'   => true,
                'message'   => 'Gagal tersambung ke OneSender',
                'data'      => array(),
                'errors'    => array(),
            ]);
        }

        $output = [
            'success' => true,
            'message' => 'Test connection success',
            'data' => [],
        ];

        return wp_send_json( $output );
	}


    public function validate( $input ) {
        $v = new Validator( $input );

        $v->rule( 'required', [
            'api_key',
            'api_url',
            'nonce', 
        ] );

        $v->rule( 'url', 'api_url' );

        return array( $v->validate(), $v->errors(), $input );
    }
}