<?php // phpcs:ignore WordPress.Files.FileName.InvalidClassFileName

/**
 * @wordpress-plugin
 * Plugin Name:       OneSender Uncanny
 * Plugin URI:        https://onesender.net
 * Description:       Integrasi OneSender dengan Uncanny Automator
 * Version:           1.0.2
 * Author:            M Ali
 * Author URI:        https://plugin.my.id
 * License:           ONESENDER
 * License URI:       http://onesender.net
 */


define( 'OSUN_VERSION',      '1.0.2' );
define( 'OSUN_BUILD_VERSION', 1000 );
define( 'OSUN_PATH',         plugin_dir_path( __FILE__ ) );
define( 'OSUN_URL',          plugin_dir_url( __FILE__ ) );
define( 'OSUN_PLUGIN_FILE',  __FILE__ );
define( 'OSUN_VIEW_DIR',     plugin_dir_path( __FILE__ ) . 'inc/resources/views' );

require_once OSUN_PATH . 'inc/bootstrap.php';

function osun_check_system_requirements() {
    global $wp_version;

    $valid = true;
    $errors = array();

    if( version_compare(PHP_VERSION, '7.4.0') <= 0 ) {
        $valid = false;
        $errors[] = 'Versi PHP minimal 7.4';
    }

    if( version_compare($wp_version, '5.9.0') <= 0 ) {
        $valid = false;
        $errors[] = 'Versi WordPress minimal 5.9';
    } 

    return array($valid, $errors);
}

list( $valid, $check_errors ) = osun_check_system_requirements();

if ( !$valid ) {
    add_action('admin_notices', function() use($check_errors) {
        echo '<div class="notice notice-error" style="padding-top: 15px;">';
        echo '<strong>Plugin OneSender Uncanny error: </strong>';
        echo '<ul>';
        foreach($check_errors as $entry) {
            echo '<li>'. $entry .'</li>';
        }
        echo '</ul>';
        echo '</div>';
    });
} else {
    $active_plugins = get_option( 'active_plugins' );

    if ( !in_array( 'uncanny-automator/uncanny-automator.php', $active_plugins ) ) {
        add_action('admin_notices', function() {
            echo '<div class="notice notice-error" style="padding-top: 15px;">';
            echo '<strong>Silahkan install dan aktifkan plugin Uncanny Automator</strong>';
            echo '<br><br></div>';
        });
    }
}

register_activation_hook( __FILE__, function() {
    require_once OSUN_PATH . 'inc/class/class-activation.php';
    \OneSender\Uncanny\Activation::do_activate();
});

